%global pkg smartpqi
%global kernel 5.10.134-17.an23
%define pkg_version 2.1.22_040
%define anolis_release 5

%define sbindir    %( if [ -d "/sbin" -a \! -h "/sbin" ]; then echo "/sbin"; else echo %{_sbindir}; fi )

Name:    kmod-%{pkg}
Version: %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release: %{pkg_version}~%{anolis_release}%{?dist}
Summary: Microchip smartpqi driver for SmartRAID/SmartHBA controllers
Vendor: Microchip Technology Inc.
License: GPLv2
Group: System Environment/Kernel
Source: kmod-%{pkg}-%{pkg_version}.tar.gz
# Source1: Module.supported
# Source2: %{pkg}-fromsrc.conf
# Source3: Makefile
# Source4: %{pkg}.conf
URL: http://www.microchip.com
Distribution: Microchip Technology Inc.
BuildRoot: /var/tmp/%{pkg}-buildroot

Requires(post):         %{sbindir}/weak-modules
Requires(post):         %{sbindir}/depmod
Requires(postun):       %{sbindir}/depmod
Requires(postun):       %{sbindir}/weak-modules
Requires(posttrans):    %{_bindir}/sort
Requires(postun):       %{_bindir}/sort
Requires:	kmod

BuildRequires:  elfutils-libelf-devel
BuildRequires:  kernel-devel = %{kernel}

%define debug_package %{nil}
%define __strip /bin/true
%description
Driver for Microchip Technology SmartRAID and SmartHBA controllers

%prep
%setup -q -n kmod-%{pkg}-%{pkg_version}

%build
make KDIR=/usr/src/kernels/%{kernel}.%{_arch}/ KVER=%{kernel}.%{_arch} build

%install
echo install %{pkg_version}-%{anolis_release}
echo "%defattr(-,root,root)" > $RPM_BUILD_DIR/file.list.%{name}

mkdir -p %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/drivers/%{pkg}

echo "/lib/modules/%{kernel}.%{_arch}/extra/drivers/%{pkg}" >>$RPM_BUILD_DIR/file.list.%{name}

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+


if modinfo smartpqi -n |xargs file |grep -c "compressed" >> /dev/null; then
        driver_bin="smartpqi.ko.xz"
elif [ $(find /lib/modules/%{kernel}.%{_arch}/ -name smartpqi.ko.xz*) ]; then
        driver_bin="smartpqi.ko.xz"
else
        driver_bin="smartpqi.ko"
fi

echo "/etc/dracut.conf.d/smartpqi-fromsrc.conf" >> $RPM_BUILD_DIR/file.list.%{name}
echo "/etc/depmod.d/smartpqi.conf" >> $RPM_BUILD_DIR/file.list.%{name}

%{__install} -D -t %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/drivers/%{pkg} src/%{pkg}.ko
if [ ${driver_bin} == "smartpqi.ko.xz" ]; then
        xz $RPM_BUILD_ROOT/lib/modules/%{kernel}.%{_arch}/extra/drivers/%{pkg}/%{pkg}.ko
fi

install -m 644 -D %{pkg}-fromsrc.conf $RPM_BUILD_ROOT/etc/dracut.conf.d/smartpqi-fromsrc.conf
install -m 644 -D %{pkg}.conf $RPM_BUILD_ROOT/etc/depmod.d/smartpqi.conf
# Generate depmod.conf
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%clean
rm -rf %{buildroot}

%post
modules=( $(find /lib/modules/%{kernel}.%{_arch}/extra/drivers/%{pkg}/ | grep '\.ko$') )
printf '%s\n' "${modules[@]}" >> /var/lib/rpm-kmod-posttrans-weak-modules-%{pkg}-add

depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/drivers/%{pkg}/%{pkg}.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi

%pretrans -p <lua>
posix.unlink("/var/lib/rpm-kmod-posttrans-weak-modules-%{name}-add")
%posttrans
if [ -f "/var/lib/rpm-kmod-posttrans-weak-modules-%{pkg}-add" ]; then
        modules=( $(cat /var/lib/rpm-kmod-posttrans-weak-modules-%{pkg}-add) )
        rm -rf /var/lib/rpm-kmod-posttrans-weak-modules-%{pkg}-add
        printf '%s\n' "${modules[@]}" | %{_sbindir}/weak-modules --dracut=/usr/bin/dracut --add-modules
fi
depmod -a %{kernel}.%{_arch}

%preun
rpm -ql kmod-%{pkg} | grep '\.ko$' > /var/run/rpm-kmod-%{pkg}-modules
if grep -q "^smartpai" /proc/modules; then
    warnMessage="WARNING: smartpqi in use.  Changes will take effect after a reboot."
    modprobe -r ${module} 2>/dev/null || echo ${warnMessage} && /usr/bin/true
fi

%postun
depmod -a > /dev/null 2>&1

# 将模块的ko从weak-modules里注销，这里的rpm-kmod-%{pkg}-modules.list是在%preun阶段生成的。
if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-kmod-%{pkg}-modules) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules --no-initramfs
fi
rm /var/run/rpm-kmod-%{pkg}-modules


# files ########################################################################
%files -f ../file.list.%{name}
%defattr(644,root,root,755)
%license licenses

%changelog
* Mon Jul 22 2024 daichx <daichx@inspur.com> - 2.1.22_040
- init smartpqi 
